Index: Makefile
===================================================================
--- Makefile	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ Makefile	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -10,7 +10,7 @@
 
 # Program variables
-objects = account.o bitlbee.o conf.o crypting.o help.o ipc.o irc.o irc_commands.o log.o nick.o query.o root_commands.o set.o storage.o $(STORAGE_OBJS) unix.o user.o
+objects = account.o bitlbee.o conf.o crypting.o help.o ini.o ipc.o irc.o irc_commands.o log.o nick.o query.o root_commands.o set.o storage.o storage_text.o unix.o url.o user.o util.o
 headers = account.h bitlbee.h commands.h conf.h config.h crypting.h help.h ini.h ipc.h irc.h log.h nick.h query.h set.h sock.h storage.h url.h user.h protocols/http_client.h protocols/md5.h protocols/nogaim.h protocols/proxy.h protocols/sha.h protocols/ssl_client.h
-subdirs = protocols lib
+subdirs = protocols
 
 # Expansion of variables
@@ -42,5 +42,5 @@
 
 distclean: clean $(subdirs)
-	rm -f Makefile.settings config.h bitlbee.pc
+	rm -f Makefile.settings config.h
 	find . -name 'DEADJOE' -o -name '*.orig' -o -name '*.rej' -o -name '*~' -exec rm -f {} \;
 
Index: account.c
===================================================================
--- account.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ account.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -28,15 +28,12 @@
 #include "account.h"
 
-char *set_eval_account( set_t *set, char *value );
-
 account_t *account_add( irc_t *irc, struct prpl *prpl, char *user, char *pass )
 {
 	account_t *a;
-	set_t *s;
 	
 	if( irc->accounts )
 	{
 		for( a = irc->accounts; a->next; a = a->next );
-		a = a->next = g_new0( account_t, 1 );
+		a = a->next = g_new0 ( account_t, 1 );
 	}
 	else
@@ -48,62 +45,7 @@
 	a->user = g_strdup( user );
 	a->pass = g_strdup( pass );
-	a->auto_connect = 1;
 	a->irc = irc;
 	
-	s = set_add( &a->set, "auto_connect", NULL, set_eval_account, a );
-	s->flags |= ACC_SET_NOSAVE;
-	
-	s = set_add( &a->set, "password", NULL, set_eval_account, a );
-	s->flags |= ACC_SET_NOSAVE;
-	
-	s = set_add( &a->set, "server", NULL, set_eval_account, a );
-	s->flags |= ACC_SET_NOSAVE | ACC_SET_OFFLINE_ONLY;
-	
-	s = set_add( &a->set, "username", NULL, set_eval_account, a );
-	s->flags |= ACC_SET_NOSAVE | ACC_SET_OFFLINE_ONLY;
-	set_setstr( &a->set, "username", user );
-	
 	return( a );
-}
-
-char *set_eval_account( set_t *set, char *value )
-{
-	account_t *acc = set->data;
-	
-	/* Double-check: We refuse to edit on-line accounts. */
-	if( set->flags & ACC_SET_OFFLINE_ONLY && acc->gc )
-		return NULL;
-	
-	if( strcmp( set->key, "username" ) == 0 )
-	{
-		g_free( acc->user );
-		acc->user = g_strdup( value );
-		return value;
-	}
-	else if( strcmp( set->key, "password" ) == 0 )
-	{
-		g_free( acc->pass );
-		acc->pass = g_strdup( value );
-		return NULL;	/* password shouldn't be visible in plaintext! */
-	}
-	else if( strcmp( set->key, "server" ) == 0 )
-	{
-		g_free( acc->server );
-		if( *value )
-			acc->server = g_strdup( value );
-		else
-			acc->server = NULL;
-		return value;
-	}
-	else if( strcmp( set->key, "auto_connect" ) == 0 )
-	{
-		if( !is_bool( value ) )
-			return NULL;
-		
-		acc->auto_connect = bool2int( value );
-		return value;
-	}
-	
-	return NULL;
 }
 
@@ -187,7 +129,4 @@
 			}
 			
-			while( a->set )
-				set_del( &a->set, a->set->key );
-			
 			g_free( a->user );
 			g_free( a->pass );
@@ -203,4 +142,6 @@
 void account_on( irc_t *irc, account_t *a )
 {
+	struct aim_user *u;
+	
 	if( a->gc )
 	{
@@ -211,6 +152,15 @@
 	cancel_auto_reconnect( a );
 	
+	u = g_new0 ( struct aim_user, 1 );
+	u->irc = irc;
+	u->prpl = a->prpl;
+	strncpy( u->username, a->user, sizeof( u->username ) - 1 );
+	strncpy( u->password, a->pass, sizeof( u->password ) - 1 );
+	if( a->server) strncpy( u->proto_opt[0], a->server, sizeof( u->proto_opt[0] ) - 1 );
+	
+	a->gc = (struct gaim_connection *) u; /* Bit hackish :-/ */
 	a->reconnect = 0;
-	a->prpl->login( a );
+	
+	a->prpl->login( u );
 }
 
Index: account.h
===================================================================
--- account.h	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ account.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -34,8 +34,5 @@
 	char *server;
 	
-	int auto_connect;
 	int reconnect;
-	
-	set_t *set;
 	
 	struct irc *irc;
@@ -50,6 +47,3 @@
 void account_off( irc_t *irc, account_t *a );
 
-#define ACC_SET_NOSAVE		1
-#define ACC_SET_OFFLINE_ONLY	2
-
 #endif
Index: bitlbee.c
===================================================================
--- bitlbee.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ bitlbee.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -291,8 +291,4 @@
 			irc_t *irc;
 			
-			/* Since we're fork()ing here, let's make sure we won't
-			   get the same random numbers as the parent/siblings. */
-			srand( time( NULL ) ^ getpid() );
-			
 			/* Close the listening socket, we're a client. */
 			close( global.listen_socket );
Index: bitlbee.h
===================================================================
--- bitlbee.h	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ bitlbee.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -130,5 +130,5 @@
 #include "query.h"
 #include "sock.h"
-#include "misc.h"
+#include "util.h"
 #include "proxy.h"
 
Index: conf.c
===================================================================
--- conf.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ conf.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -34,5 +34,5 @@
 #include "ipc.h"
 
-#include "proxy.h"
+#include "protocols/proxy.h"
 
 char *CONF_FILE;
@@ -55,6 +55,5 @@
 	conf->nofork = 0;
 	conf->verbose = 0;
-	conf->primary_storage = "xml";
-	conf->migrate_storage = g_strsplit( "text", ",", -1 );
+	conf->primary_storage = "text";
 	conf->runmode = RUNMODE_INETD;
 	conf->authmode = AUTHMODE_OPEN;
@@ -323,5 +322,5 @@
 		if( g_strcasecmp( ini->section, "defaults" ) == 0 )
 		{
-			set_t *s = set_find( &irc->set, ini->key );
+			set_t *s = set_find( irc, ini->key );
 			
 			if( s )
Index: ini.c
===================================================================
--- ini.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ ini.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,90 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2005 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* INI file reading code						*/
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+#define BITLBEE_CORE
+#include "bitlbee.h"
+
+ini_t *ini_open( char *file )
+{
+	ini_t *ini = g_new0( ini_t, 1 );
+	
+	if( ( ini->fp = fopen( file, "r" ) ) == NULL )
+	{
+		g_free( ini );
+		return( NULL );
+	}
+	
+	return( ini );
+}
+
+int ini_read( ini_t *file )
+{
+	char key[MAX_STRING], s[MAX_STRING], *t;
+	int i;
+	
+	while( !feof( file->fp ) )
+	{
+		*s = 0;
+		fscanf( file->fp, "%127[^\n#]s", s );
+		fscanf( file->fp, "%*[^\n]s" );
+		fgetc( file->fp );		/* Skip newline		*/
+		file->line ++;
+		if( strchr( s, '=' ) )
+		{
+			sscanf( s, "%[^ =]s", key );
+			if( ( t = strchr( key, '.' ) ) )
+			{
+				*t = 0;
+				strcpy( file->section, key );
+				t ++;
+			}
+			else
+			{
+				strcpy( file->section, file->c_section );
+				t = key;
+			}
+			sscanf( t, "%s", file->key );
+			t = strchr( s, '=' ) + 1;
+			for( i = 0; t[i] == ' '; i ++ );
+			strcpy( file->value, &t[i] );
+			for( i = strlen( file->value ) - 1; file->value[i] == 32; i -- )
+				file->value[i] = 0;
+			
+			return( 1 );
+		}
+		else if( ( t = strchr( s, '[' ) ) )
+		{
+			strcpy( file->c_section, t + 1 );
+			t = strchr( file->c_section, ']' );
+			*t = 0;
+		}
+	}
+	return( 0 );
+}
+
+void ini_close( ini_t *file )
+{
+	fclose( file->fp );
+	g_free( file );
+}
Index: ini.h
===================================================================
--- ini.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ ini.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,43 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* INI file reading code						*/
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#ifndef _INI_H
+#define _INI_H
+
+typedef struct
+{
+	FILE *fp;
+	int line;
+	char c_section[MAX_STRING];
+	char section[MAX_STRING];
+	char key[MAX_STRING];
+	char value[MAX_STRING];
+} ini_t;
+
+ini_t *ini_open( char *file );
+int ini_read( ini_t *file );
+void ini_close( ini_t *file );
+
+#endif
Index: irc.c
===================================================================
--- irc.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ irc.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -33,9 +33,8 @@
 GSList *irc_connection_list = NULL;
 
-static char *passchange( irc_t *irc, void *set, char *value )
-{
-	irc_setpass( irc, value );
-	irc_usermsg( irc, "Password successfully changed" );
-	return NULL;
+static char *passchange (irc_t *irc, void *set, char *value) 
+{
+	irc_setpass (irc, value);
+	return (NULL);
 }
 
@@ -121,24 +120,24 @@
 	irc_connection_list = g_slist_append( irc_connection_list, irc );
 	
-	set_add( &irc->set, "away_devoice", "true",  set_eval_away_devoice, irc );
-	set_add( &irc->set, "auto_connect", "true", set_eval_bool, irc );
-	set_add( &irc->set, "auto_reconnect", "false", set_eval_bool, irc );
-	set_add( &irc->set, "auto_reconnect_delay", "300", set_eval_int, irc );
-	set_add( &irc->set, "buddy_sendbuffer", "false", set_eval_bool, irc );
-	set_add( &irc->set, "buddy_sendbuffer_delay", "200", set_eval_int, irc );
-	set_add( &irc->set, "charset", "iso8859-1", set_eval_charset, irc );
-	set_add( &irc->set, "debug", "false", set_eval_bool, irc );
-	set_add( &irc->set, "default_target", "root", NULL, irc );
-	set_add( &irc->set, "display_namechanges", "false", set_eval_bool, irc );
-	set_add( &irc->set, "handle_unknown", "root", NULL, irc );
-	set_add( &irc->set, "lcnicks", "true", set_eval_bool, irc );
-	set_add( &irc->set, "ops", "both", set_eval_ops, irc );
-	set_add( &irc->set, "password", NULL, passchange, irc );
-	set_add( &irc->set, "private", "true", set_eval_bool, irc );
-	set_add( &irc->set, "query_order", "lifo", NULL, irc );
-	set_add( &irc->set, "save_on_quit", "true", set_eval_bool, irc );
-	set_add( &irc->set, "strip_html", "true", NULL, irc );
-	set_add( &irc->set, "to_char", ": ", set_eval_to_char, irc );
-	set_add( &irc->set, "typing_notice", "false", set_eval_bool, irc );
+	set_add( irc, "away_devoice", "true",  set_eval_away_devoice );
+	set_add( irc, "auto_connect", "true", set_eval_bool );
+	set_add( irc, "auto_reconnect", "false", set_eval_bool );
+	set_add( irc, "auto_reconnect_delay", "300", set_eval_int );
+	set_add( irc, "buddy_sendbuffer", "false", set_eval_bool );
+	set_add( irc, "buddy_sendbuffer_delay", "200", set_eval_int );
+	set_add( irc, "charset", "iso8859-1", set_eval_charset );
+	set_add( irc, "debug", "false", set_eval_bool );
+	set_add( irc, "default_target", "root", NULL );
+	set_add( irc, "display_namechanges", "false", set_eval_bool );
+	set_add( irc, "handle_unknown", "root", NULL );
+	set_add( irc, "lcnicks", "true", set_eval_bool );
+	set_add( irc, "ops", "both", set_eval_ops );
+	set_add( irc, "private", "true", set_eval_bool );
+	set_add( irc, "query_order", "lifo", NULL );
+	set_add( irc, "save_on_quit", "true", set_eval_bool );
+	set_add( irc, "strip_html", "true", NULL );
+	set_add( irc, "to_char", ": ", set_eval_to_char );
+	set_add( irc, "typing_notice", "false", set_eval_bool );
+	set_add( irc, "password", NULL, passchange);
 	
 	conf_loaddefaults( irc );
@@ -212,5 +211,5 @@
 	log_message( LOGLVL_INFO, "Destroying connection with fd %d", irc->fd );
 	
-	if( irc->status & USTATUS_IDENTIFIED && set_getint( &irc->set, "save_on_quit" ) ) 
+	if( irc->status & USTATUS_IDENTIFIED && set_getint( irc, "save_on_quit" ) ) 
 		if( storage_save( irc, TRUE ) != STORAGE_OK )
 			irc_usermsg( irc, "Error while saving settings!" );
@@ -330,8 +329,9 @@
 void irc_setpass (irc_t *irc, const char *pass) 
 {
-	g_free (irc->password);
+	if (irc->password) g_free (irc->password);
 	
 	if (pass) {
 		irc->password = g_strdup (pass);
+		irc_usermsg (irc, "Password successfully changed");
 	} else {
 		irc->password = NULL;
@@ -364,5 +364,5 @@
 			}
 			
-			if( ( cs = set_getstr( &irc->set, "charset" ) ) && ( g_strcasecmp( cs, "utf-8" ) != 0 ) )
+			if( ( cs = set_getstr( irc, "charset" ) ) && ( g_strcasecmp( cs, "utf-8" ) != 0 ) )
 			{
 				conv[IRC_MAX_LINE] = 0;
@@ -584,5 +584,5 @@
 	
 	strip_newlines( line );
-	if( ( cs = set_getstr( &irc->set, "charset" ) ) && ( g_strcasecmp( cs, "utf-8" ) != 0 ) )
+	if( ( cs = set_getstr( irc, "charset" ) ) && ( g_strcasecmp( cs, "utf-8" ) != 0 ) )
 	{
 		char conv[IRC_MAX_LINE+1];
@@ -666,5 +666,5 @@
 			}
 			
-			if( u->gc && !u->away && set_getbool( &irc->set, "away_devoice" ) )
+			if( u->gc && !u->away && set_getint( irc, "away_devoice" ) )
 				strcat( namelist, "+" );
 			
@@ -676,5 +676,5 @@
 	{
 		GList *l;
-		char *ops = set_getstr( &irc->set, "ops" );
+		char *ops = set_getstr( irc, "ops" );
 		
 		/* root and the user aren't in the channel userlist but should
@@ -924,11 +924,11 @@
 {
 	char *nick, *s;
-	char reason[128];
+	char reason[64];
 	
 	if( u->gc && u->gc->flags & OPT_LOGGING_OUT )
 	{
-		if( u->gc->acc->server )
+		if( u->gc->user->proto_opt[0][0] )
 			g_snprintf( reason, sizeof( reason ), "%s %s", irc->myhost,
-			            u->gc->acc->server );
+			            u->gc->user->proto_opt[0] );
 		else if( ( s = strchr( u->gc->username, '@' ) ) )
 			g_snprintf( reason, sizeof( reason ), "%s %s", irc->myhost,
@@ -936,5 +936,5 @@
 		else
 			g_snprintf( reason, sizeof( reason ), "%s %s.%s", irc->myhost,
-			            u->gc->acc->prpl->name, irc->myhost );
+			            u->gc->prpl->name, irc->myhost );
 		
 		/* proto_opt might contain garbage after the : */
@@ -1012,5 +1012,5 @@
 		else if( g_strncasecmp( s + 1, "TYPING", 6 ) == 0 )
 		{
-			if( u && u->gc && u->gc->acc->prpl->send_typing && strlen( s ) >= 10 )
+			if( u && u->gc && u->gc->prpl->send_typing && strlen( s ) >= 10 )
 			{
 				time_t current_typing_notice = time( NULL );
@@ -1018,5 +1018,5 @@
 				if( current_typing_notice - u->last_typing_notice >= 5 )
 				{
-					u->gc->acc->prpl->send_typing( u->gc, u->handle, s[8] == '1' );
+					u->gc->prpl->send_typing( u->gc, u->handle, s[8] == '1' );
 					u->last_typing_notice = current_typing_notice;
 				}
@@ -1051,5 +1051,5 @@
 		}
 	}
-	else if( c && c->gc && c->gc->acc && c->gc->acc->prpl )
+	else if( c && c->gc && c->gc->prpl )
 	{
 		return( bim_chat_msg( c->gc, c->id, s ) );
@@ -1083,5 +1083,5 @@
 	if( !u || !u->gc ) return;
 	
-	if( set_getint( &irc->set, "buddy_sendbuffer" ) && set_getint( &irc->set, "buddy_sendbuffer_delay" ) > 0 )
+	if( set_getint( irc, "buddy_sendbuffer" ) && set_getint( irc, "buddy_sendbuffer_delay" ) > 0 )
 	{
 		int delay;
@@ -1110,5 +1110,5 @@
 		strcat( u->sendbuf, "\n" );
 		
-		delay = set_getint( &irc->set, "buddy_sendbuffer_delay" );
+		delay = set_getint( irc, "buddy_sendbuffer_delay" );
 		if( delay <= 5 )
 			delay *= 1000;
@@ -1175,5 +1175,5 @@
 		int len = strlen( irc->nick) + 3;
 		prefix = g_new (char, len );
-		g_snprintf( prefix, len, "%s%s", irc->nick, set_getstr( &irc->set, "to_char" ) );
+		g_snprintf( prefix, len, "%s%s", irc->nick, set_getstr( irc, "to_char" ) );
 		prefix[len-1] = 0;
 	}
Index: irc_commands.c
===================================================================
--- irc_commands.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ irc_commands.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -150,8 +150,8 @@
 		irc_part( irc, u, c->channel );
 		
-		if( c->gc )
+		if( c->gc && c->gc->prpl )
 		{
 			c->joined = 0;
-			c->gc->acc->prpl->chat_leave( c->gc, c->id );
+			c->gc->prpl->chat_leave( c->gc, c->id );
 		}
 	}
@@ -173,9 +173,9 @@
 			user_t *u = user_find( irc, cmd[1] + 1 );
 			
-			if( u && u->gc && u->gc->acc->prpl->chat_open )
+			if( u && u->gc && u->gc->prpl && u->gc->prpl->chat_open )
 			{
 				irc_reply( irc, 403, "%s :Initializing groupchat in a different channel", cmd[1] );
 				
-				if( !u->gc->acc->prpl->chat_open( u->gc, u->handle ) )
+				if( !u->gc->prpl->chat_open( u->gc, u->handle ) )
 				{
 					irc_usermsg( irc, "Could not open a groupchat with %s.", u->nick );
@@ -205,7 +205,7 @@
 	
 	if( u && c && ( u->gc == c->gc ) )
-		if( c->gc && c->gc->acc->prpl->chat_invite )
-		{
-			c->gc->acc->prpl->chat_invite( c->gc, c->id, "", u->handle );
+		if( c->gc && c->gc->prpl && c->gc->prpl->chat_invite )
+		{
+			c->gc->prpl->chat_invite( c->gc, c->id, "", u->handle );
 			irc_reply( irc, 341, "%s %s", nick, channel );
 			return;
@@ -230,5 +230,5 @@
 		{
 			unsigned int i;
-			char *t = set_getstr( &irc->set, "default_target" );
+			char *t = set_getstr( irc, "default_target" );
 			
 			if( g_strcasecmp( t, "last" ) == 0 && irc->last_target )
@@ -477,6 +477,6 @@
 		
 		if( u->gc )
-			irc_reply( irc, 312, "%s %s.%s :%s network", u->nick, u->gc->acc->user,
-			           *u->gc->acc->server ? u->gc->acc->server : "", u->gc->acc->prpl->name );
+			irc_reply( irc, 312, "%s %s.%s :%s network", u->nick, u->gc->user->username,
+			           *u->gc->user->proto_opt[0] ? u->gc->user->proto_opt[0] : "", u->gc->prpl->name );
 		else
 			irc_reply( irc, 312, "%s %s :%s", u->nick, irc->myhost, IRCD_INFO );
Index: nick.c
===================================================================
--- nick.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ nick.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -86,5 +86,5 @@
 		
 		nick_strip( nick );
-		if( set_getint( &irc->set, "lcnicks" ) )
+		if (set_getint(irc, "lcnicks")) 
 			nick_lc( nick );
 	}
Index: protocols/Makefile
===================================================================
--- protocols/Makefile	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ protocols/Makefile	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -10,5 +10,5 @@
 
 # [SH] Program variables
-objects = nogaim.o
+objects = $(EVENT_HANDLER) http_client.o md5.o nogaim.o proxy.o sha.o $(SSL_CLIENT)
 
 # [SH] The next two lines should contain the directory name (in $(subdirs))
Index: protocols/events.h
===================================================================
--- protocols/events.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ protocols/events.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,66 @@
+/*
+ * nogaim
+ *
+ * Copyright (C) 2006 Wilmer van der Gaast and others
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+/*
+ * Split off the event handling things from proxy.[ch] (and adding timer
+ * stuff. This to allow BitlBee to use other libs than GLib for event
+ * handling.
+ */
+
+
+#ifndef _EVENTS_H_
+#define _EVENTS_H_
+
+#include <sys/types.h>
+#ifndef _WIN32
+#include <sys/socket.h>
+#include <netdb.h>
+#include <netinet/in.h>
+#endif
+#include <glib.h>
+#include <gmodule.h>
+
+typedef enum {
+	GAIM_INPUT_READ = 1 << 1,
+	GAIM_INPUT_WRITE = 1 << 2
+} b_input_condition;
+typedef gboolean (*b_event_handler)(gpointer data, gint fd, b_input_condition cond);
+
+#define GAIM_READ_COND  (G_IO_IN | G_IO_HUP | G_IO_ERR)
+#define GAIM_WRITE_COND (G_IO_OUT | G_IO_HUP | G_IO_ERR | G_IO_NVAL)
+#define GAIM_ERR_COND   (G_IO_HUP | G_IO_ERR | G_IO_NVAL)
+
+// #define event_debug( x... ) printf( x )
+#define event_debug( x... )
+
+G_MODULE_EXPORT void b_main_init();
+G_MODULE_EXPORT void b_main_run();
+G_MODULE_EXPORT void b_main_quit();
+
+G_MODULE_EXPORT gint b_input_add(int fd, b_input_condition cond, b_event_handler func, gpointer data);
+G_MODULE_EXPORT gint b_timeout_add(gint timeout, b_event_handler func, gpointer data);
+G_MODULE_EXPORT void b_event_remove(gint id);
+
+#ifdef EVENTS_LIBEVENT
+G_MODULE_EXPORT void closesocket(int fd);
+#endif
+
+#endif /* _EVENTS_H_ */
Index: protocols/events_glib.c
===================================================================
--- protocols/events_glib.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ protocols/events_glib.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,137 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2006 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/*
+ * Event handling (using GLib)
+ */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/types.h>
+#ifndef _WIN32
+#include <sys/socket.h>
+#include <netdb.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+#include <unistd.h>
+#else
+#include "sock.h"
+#define ETIMEDOUT WSAETIMEDOUT
+#define EINPROGRESS WSAEINPROGRESS
+#endif
+#include <fcntl.h>
+#include <errno.h>
+#include "proxy.h"
+
+typedef struct _GaimIOClosure {
+	b_event_handler function;
+	guint result;
+	gpointer data;
+} GaimIOClosure;
+
+static GMainLoop *loop;
+
+void b_main_init()
+{
+	loop = g_main_new( FALSE );
+}
+
+void b_main_run()
+{
+	g_main_run( loop );
+}
+
+void b_main_quit()
+{
+	g_main_quit( loop );
+}
+
+static gboolean gaim_io_invoke(GIOChannel *source, GIOCondition condition, gpointer data)
+{
+	GaimIOClosure *closure = data;
+	b_input_condition gaim_cond = 0;
+	gboolean st;
+
+	if (condition & GAIM_READ_COND)
+		gaim_cond |= GAIM_INPUT_READ;
+	if (condition & GAIM_WRITE_COND)
+		gaim_cond |= GAIM_INPUT_WRITE;
+	
+	event_debug( "gaim_io_invoke( %d, %d, 0x%x )\n", g_io_channel_unix_get_fd(source), condition, data );
+
+	st = closure->function(closure->data, g_io_channel_unix_get_fd(source), gaim_cond);
+	
+	if( !st )
+		event_debug( "Returned FALSE, cancelling.\n" );
+	
+	return st;
+}
+
+static void gaim_io_destroy(gpointer data)
+{
+	event_debug( "gaim_io_destroy( 0x%x )\n", data );
+	g_free(data);
+}
+
+gint b_input_add(gint source, b_input_condition condition, b_event_handler function, gpointer data)
+{
+	GaimIOClosure *closure = g_new0(GaimIOClosure, 1);
+	GIOChannel *channel;
+	GIOCondition cond = 0;
+	
+	closure->function = function;
+	closure->data = data;
+	
+	if (condition & GAIM_INPUT_READ)
+		cond |= GAIM_READ_COND;
+	if (condition & GAIM_INPUT_WRITE)
+		cond |= GAIM_WRITE_COND;
+	
+	channel = g_io_channel_unix_new(source);
+	closure->result = g_io_add_watch_full(channel, G_PRIORITY_DEFAULT, cond,
+					      gaim_io_invoke, closure, gaim_io_destroy);
+	
+	event_debug( "b_input_add( %d, %d, 0x%x, 0x%x ) = %d (0x%x)\n", source, condition, function, data, closure->result, closure );
+	
+	g_io_channel_unref(channel);
+	return closure->result;
+}
+
+gint b_timeout_add(gint timeout, b_event_handler func, gpointer data)
+{
+	gint st = g_timeout_add(timeout, func, data);
+	
+	event_debug( "b_timeout_add( %d, %d, %d ) = %d\n", timeout, func, data, st );
+	
+	return st;
+}
+
+void b_event_remove(gint tag)
+{
+	event_debug( "b_event_remove( %d )\n", tag );
+	
+	if (tag > 0)
+		g_source_remove(tag);
+}
